#ifndef REPAIR_HPP
#define	REPAIR_HPP

#include "events.hpp"
#include "machine.hpp"
#include <vector>
#include <eosim/core/model.hpp>
#include <eosim/core/renewable.hpp>
#include <eosim/dist/negexpdist.hpp>
#include <eosim/dist/normaldist.hpp>
#include <eosim/utils/entityqueuefifo.hpp>

class Repair: public eosim::core::Model {
private:
	EndWork eW;
	EndRemove eRv;
	EndRepair eRp;
	StartRemove sRv;
	StartRepair	sRp;
	std::vector<Machine*> machine;
public:
	int numMachinesBroken;
	eosim::core::Renewable mechanics;
	eosim::core::Renewable equipment;

	eosim::dist::NegexpDist breakDown;
	eosim::dist::NormalDist removal;
	eosim::dist::NormalDist repair;

	eosim::utils::EntityQueueFifo toRemove;
	eosim::utils::EntityQueueFifo toRepair;

	Repair(int cantMech, int cantEq, int cantMach, double breakDownTime,
		double removalMean, double removalSD, double repairMean, double repairSD);
	~Repair();
	void init();
	void doInitialSchedules();
};


#endif



