#ifndef DIST_HPP_
#define DIST_HPP_

#include <eosim/dist/distmanager.hpp>
#include <eosim/dist/distribution.hpp>
#include <eosim/dist/lognormaldist.hpp>
#include <eosim/dist/ccalendar.hpp>
#include <eosim/dist/negexpdist.hpp>
#include <eosim/dist/normaldist.hpp>
#include <eosim/dist/numbergenerator.hpp>
#include <eosim/dist/numbergeneratorfactory.hpp>
#include <eosim/dist/poissondist.hpp>
#include <eosim/dist/uniformdist.hpp>

/**
 * \defgroup dist_group Distributions
 * <br>
 * <p>EOSimulators Distribution Module contains facilities for random number generation and distribution sampling.</p>
 * <p>In this module we have encapsulated pseudo-random generators and distribution sampling. All distributions
 * are subclasses of Distribution, an abstract class which defines the behavior of every distribution in
 * EOSimulator. Every distribution has a pseudo-random number generator, defined by the interface NumberGenerator.</p>
 * <p>Finally NumberGeneratorFactory creates NumberGenerators according to the corresponding GenType label. This
 * design allows the user to define both new generators and distribution.</p>
*/

#endif

