#ifndef BIN_HPP_
#define BIN_HPP_

/** \class eosim::core::Bin include\eosim\core\bin.hpp <eosim/core/bin.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Abstract Bin
 
 * This is the parent class of all Bins.
*/

namespace eosim {

namespace core {

	class Bin {
	protected:
		double quantity;
		/**
		* \brief The constructor of Bin.
		*/
		Bin(double quantity);
	public:
		/**
		* \brief The destructor of Bin.
		*/
		virtual ~Bin();
		/**
		* \brief This operation acquires amount units of the bin.
		*/
		void acquire (double amount);
		/**
		* \brief This operation returns if there is at least amount units of bin available.
		*/
		bool isAvailable (double amount);
		/**
		* \brief This operation returns the actual amount of bins available.
		*/
		double getQuantity();
	};

}

}

#endif

