#ifndef CCALENDAR_HPP_
#define CCALENDAR_HPP_

#include <eosim/core/cevent.hpp>
#include <eosim/utils/ceventvector.hpp>

/** \ingroup simuling_group
 * \@{
*/
/** \class eosim::core::CCalendar include\eosim\core\ccalendar.hpp <eosim/core/ccalendar.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  C Events Calendar
 
 * This class handles the simulations C phase. In the three phase approach, after every B phase all conditional event are executed.
*/

namespace eosim {

namespace core {

	class CCalendar {
	private:
		utils::CEventVector cEvs;
	public:
		/**
		* \brief The constructor creates an empty CCalendar ready to operate.
		*/
		CCalendar ();
		/**
		* \brief The destructor of CCalendar.
		*/
		~CCalendar ();
		/**
		* \brief This operation executes all the registered CEvents.
		*/
		void cPhase ();
		/**
		* \brief This operation register cEv in the CCalendar.
		*/
		void registerCEvent (CEvent* cEv);
	};

}

}

/**
 * \@}
*/

#endif

