#ifndef NONRENEWABLE_HPP_
#define NONRENEWABLE_HPP_

#include <eosim/core/bin.hpp>

/** \class eosim::core::NonRenewable include\eosim\core\nonrenewable.hpp <eosim/core/nonrenewable.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Nonrenewable Bin
 
 * This class represent bins which are consumable, like coffee. This kind of bins are consume while they are used. So you can use them and add some more before it is depleted. It inherits the acquire operation from its parent class, Bin.
*/


namespace eosim {

namespace core {

	class NonRenewable: public Bin {
	public:
		/**
		* \brief The constructor creates a NonRenewable bin with a quantity units.
		*/
		NonRenewable (double quantity);
		/**
		* The destructor of NonRenewable.
		*/
		~NonRenewable ();
		/**
		* \brief This operation add amount units to the bin.
		*/
		void addBin (double amount);	
	};

}

}

#endif

