#ifndef LOGNORMALDIST_HPP_
#define LOGNORMALDIST_HPP_

#include <eosim/dist/distribution.hpp>

/** \ingroup dist_group
 * \@{
*/
/** \class eosim::dist::LogNormalDist include\eosim\dist\lognormaldist.hpp <eosim/dist/lognormaldist.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Log Normal Distribution
 
 * This class sample values from a log normal distribution.
*/




namespace eosim {
	
namespace dist {

	class LogNormalDist: public Distribution {
	private:
		double m, sd;
	public:
		/**
		* \brief The constructor creates a LogNormalDist with mean m, standard deviation sd and whose generators type is gen.
		* \note The parameters m and sd are from the normal distribution that the logarithms of the data adjust.
		*/
		LogNormalDist (GenType gen, double m, double sd);
		/**
		* The destructor of LogNormalDist.
		*/
		~LogNormalDist ();
		/**
		* This operation samples a value from the distribution.
		*/
		double sample ();
	};

}

}

/**
 * \@}
*/

#endif

