#ifndef NEGEXPDIST_HPP_
#define NEGEXPDIST_HPP_

#include <eosim/dist/distribution.hpp>

/** \ingroup dist_group
 * \@{
*/
/** \class eosim::dist::NegexpDist include\eosim\dist\negexpdist.hpp <eosim/dist/negexpdist.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Negative Exponential Distribution
 
 * This class sample values from a negative exponential distribution.
*/


            

namespace eosim {
	
namespace dist {

	class NegexpDist: public Distribution {
	private:
		double m;
	public:
		/**
		* \brief The constructor creates a NegexpDist with mean m and whose generators type is gen.
		*/
		NegexpDist (GenType gen, double m);
		/**
		* \brief The destructor of NegexpDist.
		*/
		~NegexpDist ();
		/**
		* \brief This operation samples a value from the distribution.
		*/
		double sample ();
	};

}

}

/**
 * \@}
*/

#endif

