#ifndef NORMALDIST_HPP_
#define NORMALDIST_HPP_

#include <eosim/dist/distribution.hpp>

/** \ingroup dist_group
 * \@{
*/
/** \class eosim::dist::NormalDist include\eosim\dist\normaldist.hpp <eosim/dist/normaldist.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Normal Distribution
 
 * This class sample values from a normal distribution.
*/

            


namespace eosim {
	
namespace dist {

	class NormalDist: public Distribution {
	private:
		double m, sd;
	public:
		/**
		* \brief The constructor creates a NormalDist with mean m, standard deviation sd and whose generators type is gen.
		*/
		NormalDist (GenType gen, double m, double sd);
		/**
		* \brief The destructor of NormalDist.
		*/
		~NormalDist ();
		/**
		* \brief This operation samples a value the distribution.
		*/
		double sample ();
	};

}

}

/**
 * \@}
*/

#endif

