#ifndef NUMBERGENERATORFACTORY_HPP_
#define NUMBERGENERATORFACTORY_HPP_

#include <eosim/dist/numbergenerator.hpp>

/** \ingroup dist_group
 * \@{
*/
/** \class eosim::dist::NumberGeneratorFactory include\eosim\dist\numbergeneratorfactory.hpp <eosim/dist/numbergeneratorfactory.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Random Number Generator Factory
 
 * This class is a factory of random number generator classes. It returns a new generator whose type is type.
*/


namespace eosim {
	
namespace dist {

	class NumberGeneratorFactory {
	public:
		/**
		* \brief It returns a pointer to a new generator whose type is type.
		* \note Every generator is identified by a GenType label. The generator returned has to be deleted by the programmer. In order to add new generators the code of this function has to be rewritten and GenType has to be updated by adding a new label for the generator.
		*/
        static NumberGenerator* make(GenType type); 
	};

}

}

/**
 * \@}
*/

#endif

