#ifndef UNIFORMDIST_HPP_
#define UNIFORMDIST_HPP_

#include <eosim/dist/distribution.hpp>

/** \ingroup dist_group
 * \@{
 * \class eosim::dist::UniformDist include\eosim\dist\uniformdist.hpp <eosim/dist/uniformdist.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.0.1
 *  \date    2005
 *  \brief  Uniform Distribution
 
 * This class sample values from a uniform distribution.
*/


namespace eosim {
	
namespace dist {

	class UniformDist: public Distribution {
	private:
		double low, upper;
	public:
		/**
		* \brief The constructor creates a UniformDist with lower bound low, upper bound upper and whose whose generators type is gen.
		*/
		UniformDist (GenType gen, double low, double upper);
		/**
		* \brief The destructor of UniformDist.
		*/
		~UniformDist ();
		/**
		* \brief This operation samples a value from the distribution.
		*/
		double sample ();
	};

}

}

/**
 * \@}
*/

#endif

