#ifndef OBSERVATION_HPP_
#define OBSERVATION_HPP_

#include <eosim/statics/histogram.hpp>

/** \ingroup statics_group
 * \@{
*/
/** \class eosim::statics::Observation include\eosim\statics\observation.hpp <eosim/statics/observation.hpp>
 *  \author Sebastin Alaggia
 *  \version 1.1.0
 *  \date    2005
 *  \brief  Observation Histogram
 
 * This is histograms is used to store values of discrete observations, such us waitting times.
 * Basically it defines a <b>observed value vs. quantity of observations</b> chart (counts the number of times a value was observed).
*/


namespace eosim {

namespace statics {
	class Observation: public Histogram {
	public:
		/**
		* \brief The constructor of Observation; the kind of histogram is appended at the end of the name.
		*/
		Observation(std::string name);
		/**
		* \brief This operation log a value in the histogram.
		*/
		void log(double value);
	};

}

}

/**
 * \@}
*/

#endif

