#include <eosim/core/bin.hpp>
#include <cassert>

using namespace eosim::core;

Bin::Bin(double quantity): quantity(quantity) {
    /**
	 * \warning A bin must be created with a non negative quantity.
	*/
	assert(quantity >= 0 && "Bin::Bin: Error creating a bin");
}

Bin::~Bin() {}

void Bin::acquire (double amount) {
    /**
	 * \warning To acquire certain amount of a bin you must be sure that there is enoght units of the bin to satisfy your request.
	*/
	assert(amount <= quantity && "Bin::acquiere: Error aquiring a bin"); 
	quantity -= amount;
}

bool Bin::isAvailable (double amount) {
 return quantity >= amount;
}

double Bin::getQuantity() {
	return quantity;
}
