#include <eosim/core/entity.hpp>
#include <eosim/core/bevent.hpp>
#include <cassert>

using namespace eosim::core;


Entity::Entity (): bEv(0), clock(0) {}

Entity::~Entity () {}

void Entity::setBEvent (BEvent* bEv) {
	/**
	* \note Entities have to know to which event they are scheduled. The BCalendar only schedule the entity to a certain time, not to a certain event.
	*/
    /**
	* \waring The programmer should not use this operation, it is invoked directly by EOSimulator.
	* \waring If setBEvent is invoked with null, the simulation aborts immediately displaying an error message. 
	*/
    assert(bEv != 0 && "Entity::setBEvent: Error assigning a BEvent");
    this->bEv = bEv;
}

void Entity::setClock (double clock) {
    this->clock = clock;
}

double Entity::getClock () {
    return clock;
}

void Entity::processEvent () {
    bEv->eventRoutine(this);
}

