#include <eosim/core/nonrenewable.hpp>
#include <cassert>

using namespace eosim::core;


NonRenewable::NonRenewable(double quantity): Bin(quantity) {
	/**
	* \warning A non renewable bin must be created with a non negative quantity.
	*/
}

NonRenewable::~NonRenewable() {}

void NonRenewable::addBin(double amount) {
	/**
	* \warning The amount added must be non negative.
	*/
    assert(amount >= 0 && "NonRenewable::addBin: Error adding NonRenewable bins");
    quantity += amount;
}

