#include <eosim/dist/distmanager.hpp>
#include <eosim/dist/numbergeneratorfactory.hpp>

using namespace eosim::dist;
using namespace eosim::utils;


DistManager::DistManager (GenType seedGenerator): seedGenerator(NumberGeneratorFactory::make(seedGenerator)) {}

DistManager::~DistManager () {
	/**
	* \note This operation dont delete any registered distribution.
	*/
    delete seedGenerator;
}

void DistManager::setSeed (unsigned long seed) {
	/**
	* \note It uses both seed and its seed generator for assigning new seed to every registered distribution.
	*/
    seedGenerator->setSeed(seed);
    for ( unsigned int i = 0; i < dVect.size(); i++) {
        dVect[i]->setSeed(seedGenerator->nextLong());
    }
}

void DistManager::registerDist (Distribution* d) {
    dVect.push(d);
}

