#include <eosim/dist/lognormaldist.hpp>
#include <cmath>

const double tpi = 6.2831852;

using namespace eosim::dist;


LogNormalDist::LogNormalDist(GenType gen, double m, double sd):
                       Distribution(gen), m(m), sd(sd) {} 


LogNormalDist::~LogNormalDist() {}

double LogNormalDist::sample() {
	/**
	* \note The method used for sampling is the Box-Muller method.
	*/
    double x, xs, xm;
    x = log (sd/m+1);
    xs = sqrt (x);
    xm = log (m)-0.5*x;
    return exp (sin(tpi * generator->nextDouble()) * 
           sqrt( -2 * log(generator->nextDouble())) * xs + xm);
}

