#include <eosim/dist/normaldist.hpp>
#include <cmath>

const double tpi = 6.2831852;

using namespace eosim::dist;


NormalDist::NormalDist(GenType gen, double m, double sd):
                       Distribution(gen), m(m), sd(sd) {} 

NormalDist::~NormalDist() {}

double NormalDist::sample() {
	/**
	* \note The method used for sampling is the Box-Muller method.
	*/
    return sin(tpi * generator->nextDouble()) * 
           sqrt(-2 * log(generator->nextDouble())) * sd + m;
}

