#include <eosim/dist/poissondist.hpp>
#include <cmath>


using namespace eosim::dist;


PoissonDist::PoissonDist(GenType gen, double m):
                         Distribution(gen), m(m) {} 

PoissonDist::~PoissonDist() {}

double PoissonDist::sample() {
	/**
	* \note The value is calculated iteratively.
	*/
    double rnd, p;
    unsigned int x;
    rnd = generator->nextDouble();
    p = exp(-m);
    x = 0;
    for (double f = p ;rnd > f; f += p) {
        x++;
        p *= (m/x);
    }
    return x;
}

