#include <eosim/statics/timeseries.hpp>
#include <eosim/core/model.hpp>
#include <cassert>

using namespace eosim::statics;

TimeSeries::TimeSeries(std::string name, eosim::core::Model &m) : m(m), Histogram(name + " - Time Series Histogram") {}

void TimeSeries::log(double value) {
	/**
	 * \note The value is logged with the actual simulation time.
	 * Remember that histograms acummulate values with the same x's.
	*/
	Histogram::log(m.getSimTime(), value);
}

