#include <eosim/statics/timeweighted.hpp>
#include <eosim/core/model.hpp>
#include <cassert>

using namespace eosim::statics;


TimeWeighted::TimeWeighted(std::string name, eosim::core::Model &m) : m(m), lastTime(0), Histogram(name + " - Time Weigthed Histogram") {}

void TimeWeighted::log(double value) {
	/**
	 * \note The value is logged with the amount of time it sustained.
	 * This amount of time is automatically calculated and updated.
	*/
	Histogram::log(value, m.getSimTime() - lastTime);
	lastTime = m.getSimTime();
}

