#include <eosim/utils/ceventvector.hpp>
#include <cassert>

using namespace eosim::utils;
using namespace eosim::core;
using namespace std;


CEventVector::CEventVector () {}

CEventVector::~CEventVector () {
	/**
	* \note This operation doesnt delete any CEvents stored.
	*/
}

void CEventVector::push (CEvent* elem) {
    elems.push_back(elem);
}

void CEventVector::remove (unsigned int i) {
	/**
	* \warning i must be within the limits of the vector.
	*/
	assert(i < elems.size() && "CEventVector::remove: Error removing a CEvent from a CEventVector");
    elems.erase(elems.begin() + i);
}

CEvent* CEventVector::operator[] (unsigned int i) {
	/**
	* \warning i must be within the limits of the vector.
	*/
    assert(i < elems.size() && "CEventVector::operator[]: Error indexing in a CEventVector");
    return elems[i];
}

unsigned int CEventVector::size() {
    return elems.size();
}

