#include <eosim/utils/distvector.hpp>
#include <cassert>

using namespace eosim::utils;
using namespace eosim::dist;
using namespace std;


DistVector::DistVector () {}

DistVector::~DistVector () {
	/**
	* \note This operation doesnt delete any Distributions stored.
	*/
}

void DistVector::push (Distribution* elem) {
    elems.push_back(elem);
}

void DistVector::remove (unsigned int i) {
	/**
	* \warning i must be within the limits of the vector.
	*/
    assert(i < elems.size() && "DistVector::remove: Error removing a Distribution from a DistVector");
    elems.erase(elems.begin() + i);
}

Distribution*& DistVector::operator[] (unsigned int i) {
	/**
	* \note The use of this operation is either dVect[i] or dVect.operator[](i).
	* \warning i must be within the limits of the vector.
	*/
    assert(i < elems.size() && "DistVector::operator[]:  Error indexing in a DistVector");
    return elems[i];
}

unsigned int DistVector::size() {
    return elems.size();
}

