#include <eosim/utils/entityqueuelifo.hpp>
#include <cassert>

using namespace eosim::core;
using namespace eosim::utils;
using namespace std;


EntityQueueLifo::EntityQueueLifo() {}

EntityQueueLifo::~EntityQueueLifo() {
    for (deque<Entity*>::iterator i = elems.begin(); i != elems.end(); i++) {
        delete *i;
    }
}

void EntityQueueLifo::push(Entity* ent) {
    elems.push_front(ent);
}

Entity* EntityQueueLifo::pop() {
	/**
	* \warning The queue is must not be empty.
	*/
    assert(elems.size() > 0 && "EntityQueueLifo::pop: Error removing the first element of a EntityQueueLifo");
    Entity* e = elems.front();
    elems.pop_front();
    return e;
} 

void EntityQueueLifo::remove(unsigned int i) {
	/**
	* \warning i must be within the limits of the queue.
	*/
    assert(i < elems.size() && "EntityQueueLifo::remove: Error removing an Entity from an EntityQueueLifo");
    elems.erase(elems.begin() + i);
}

bool EntityQueueLifo::empty() {
    return elems.empty();
}

Entity* EntityQueueLifo::operator[] (unsigned int i) {
	/**
	* \warning i must be within the limits of the queue.
	*/
    assert(i < elems.size() && "EntityQueueLifo::operator[]: Error indexing in a EntityQueueLifo");
    return elems[i];
}

unsigned int EntityQueueLifo::size() {
    return elems.size();
}

